-- name: [CS] + [PET] "SONIC"
-- description: What's wrong?\nIt's just your old pal...\n\\#32325a\\SONIC!\n\n\\#ffffff\\Model made by \\#007FFF\\5UP34\n\\#ffffff\\Character made by \\#820d2e\\Raven\n\\#ffffff\\Now owned by \\#9c1c69\\ItsAlepie\n\\#ffffff\\2017x Voiced by\n\\#22577a\\SimitarchVOs\n\\#ffffff\\Other Stuff made by \\#a019e3\\DM-kun\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!
-- category: cs

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "2017x Character Pack"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

--[[
    Everything from here down is character data,
    which is loaded at the end of the file
]]

-- All Located in "actors"
local E_MODEL_SONIC = smlua_model_util_get_id("sonic17_geo")
local E_MODEL_BROKEN_FACE = smlua_model_util_get_id("breakface_geo")
--local E_MODEL_SONIC_STAR = smlua_model_util_get_id("custom_model_star_geo")

--[[
local CAPTABLE_SONIC = {
    normal = smlua_model_util_get_id("sonic17_cap_geo"),
    wing = smlua_model_util_get_id("sonic17_wing_cap_geo"),
    metal = smlua_model_util_get_id("sonic17_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("sonic17_winged_metal_cap_geo"),
}

local CAPTABLE_BROKEN_FACE = {
    normal = smlua_model_util_get_id("sonic17_cap_geo"),
    wing = smlua_model_util_get_id("sonic17_wing_cap_geo"),
    metal = smlua_model_util_get_id("sonic17_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("sonic17_winged_metal_cap_geo"),
}
]]

-- All Located in "sound"
local VOICETABLE_SONIC = {
    [CHAR_SOUND_OKEY_DOKEY] =        'sonic17_startGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'sonic17_startLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'sonic17_punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'sonic17_punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'sonic17_punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'sonic17_jump1.ogg', 'sonic17_jump2.ogg', 'sonic17_jump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'sonic17_doubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'sonic17_tripleJump1.ogg', 'sonic17_tripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'sonic17_bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'sonic17_longJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'sonic17_longJumpLand.ogg',
	[CHAR_SOUND_HAHA] =              'sonic17_tripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'sonic17_longJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'sonic17_bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'sonic17_grabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'sonic17_climbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'sonic17_falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'sonic17_flowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'sonic17_groundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'sonic17_lift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'sonic17_getStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'sonic17_throwBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'sonic17_damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'sonic17_panting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'sonic17_burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'sonic17_tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'sonic17_yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = nil, --[CHAR_SOUND_SNORING1] = 'sonic17_snore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = nil, --[CHAR_SOUND_SNORING2] = 'sonic17_exhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = nil, --[CHAR_SOUND_SNORING3] = 'sonic17_sleeptalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'sonic17_cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'sonic17_cough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'sonic17_cough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'sonic17_dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'sonic17_drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'sonic17_leaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_BROKEN_FACE = {
    [CHAR_SOUND_OKEY_DOKEY] =        'sonic17_startGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'sonic17_startLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'sonic17_punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'sonic17_punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'sonic17_punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'sonic17_jump1.ogg', 'sonic17_jump2.ogg', 'sonic17_jump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'sonic17_doubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'sonic17_tripleJump1.ogg', 'sonic17_tripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'sonic17_bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'sonic17_longJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'sonic17_longJumpLand.ogg',
	[CHAR_SOUND_HAHA] =              'sonic17_tripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'sonic17_longJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'sonic17_bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'sonic17_grabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'sonic17_climbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'sonic17_falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'sonic17_flowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'sonic17_groundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'sonic17_lift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'breakface_getStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'breakface_throwBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'sonic17_damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'sonic17_panting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'sonic17_burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'breakface_tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'sonic17_yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = nil, --[CHAR_SOUND_SNORING1] = 'sonic17_snore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = nil, --[CHAR_SOUND_SNORING2] = 'sonic17_exhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = nil, --[CHAR_SOUND_SNORING3] = 'sonic17_sleeptalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'sonic17_cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'sonic17_cough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'sonic17_cough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'sonic17_dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'sonic17_drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'breakface_leaveLevel.ogg' -- Booted out of level
}

-- All Located in "textures"
local TEX_SONIC_LIFE_ICON = get_texture_info("sonic17-icon")
local TEX_BROKEN_FACE_LIFE_ICON = get_texture_info("breakface-icon")
--local TEX_SONIC_STAR_ICON = get_texture_info("exclamation-icon")

local HEALTH_METER_SONIC = {
    label = {
        left = get_texture_info("sonic-hp-back-left"),
        right = get_texture_info("sonic-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("sonic-hp-pie-1"),
        [2] = get_texture_info("sonic-hp-pie-2"),
        [3] = get_texture_info("sonic-hp-pie-3"),
        [4] = get_texture_info("sonic-hp-pie-4"),
        [5] = get_texture_info("sonic-hp-pie-5"),
        [6] = get_texture_info("sonic-hp-pie-6"),
        [7] = get_texture_info("sonic-hp-pie-7"),
        [8] = get_texture_info("sonic-hp-pie-8"),
    }
}

local COURSE_METER_SONIC = {
    top = get_texture_info("sonic-course-top"),
    bottom = get_texture_info("sonic-course-bottom"),
}

local PALETTE_SONIC = {
    [PANTS]  = "161924",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "000000",
    [SHOES]  = "000000",
    [HAIR]   = "000000",
    [SKIN]   = "97998D",
    [CAP]    = "000000",
    [EMBLEM] = "000000",
}

local DESCRIPTION_SONIC = {
    "What's wrong...?",
    "It's just me!",
    "Your old pal...",
    "",
    "S O N I C"
}

local DESCRIPTION_BROKEN_FACE = {
    "I AM THE REAL SONIC!",
    "AND IF YOU WON'T BELIEVE IT...",
    "",
    "I ' L L   M A K E   Y O U",
    "B E L I E V E   I T"
}

--[[
    Everything from here down is where the data is applied
]]

local CSloaded = false
local function on_character_select_load()
    -- Fraud
    CT_2017X = _G.charSelect.character_add(
        "\"SONIC\"",
        DESCRIPTION_SONIC,
        "5UP34 / VA: SimitarchVOs",
        {r = 90, g = 90, b = 110},
        E_MODEL_SONIC,
        CT_MARIO,
        TEX_SONIC_LIFE_ICON,
        1,
        0
    )
    -- _G.charSelect.character_add_caps(E_MODEL_SONIC, CAPTABLE_SONIC)
    _G.charSelect.character_add_voice(E_MODEL_SONIC, VOICETABLE_SONIC)
    --_G.charSelect.character_add_celebration_star(E_MODEL_SONIC, E_MODEL_SONIC_STAR, TEX_SONIC_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_SONIC, PALETTE_SONIC)
    _G.charSelect.character_add_health_meter(CT_2017X, HEALTH_METER_SONIC)
    _G.charSelect.character_add_course_texture(CT_2017X, COURSE_METER_SONIC)

    -- Breaking Facade
    -- Fraud with broken eye and stuff
    -- Maybe some other time

    -- Broken Face
    _G.charSelect.character_add_costume(
        CT_2017X,
        "Broken Face",
        DESCRIPTION_BROKEN_FACE,
        "5UP34 / VA: SimitarchVOs",
        {r = 30, g = 30, b = 50},
        E_MODEL_BROKEN_FACE,
        CT_WALUIGI,
        TEX_BROKEN_FACE_LIFE_ICON,
        1.8,
        35
    )
    -- _G.charSelect.character_add_caps(E_MODEL_BROKEN_FACE, CAPTABLE_BROKEN_FACE)
    _G.charSelect.character_add_voice(E_MODEL_BROKEN_FACE, VOICETABLE_BROKEN_FACE)
    --_G.charSelect.character_add_celebration_star(E_MODEL_BROKEN_FACE, E_MODEL_SONIC_STAR, TEX_SONIC_STAR_ICON)
    --_G.charSelect.character_add_palette_preset(E_MODEL_BROKEN_FACE, PALETTE_BROKEN_FACE)
    _G.charSelect.character_add_costume_health_meter(CT_2017X, 2, HEALTH_METER_SONIC)
    _G.charSelect.character_add_costume_course_texture(CT_2017X, 2, COURSE_METER_SONIC)

    -- Credits
    _G.charSelect.credit_add(TEXT_MOD_NAME, "5UP34", "Model Creator")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "Raven", "Character Creator")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "ItsAlepie", "Character Owner")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "SimitarchVOs", "2017x VA")
    _G.charSelect.credit_add(TEXT_MOD_NAME, "DM-kun", "Pack + Other Stuff")

    CSloaded = true
end

-- Character Voice hooks
local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SONIC then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BROKEN_FACE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SONIC then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BROKEN_FACE then return _G.charSelect.voice.snore(m) end
end

-- Custom Song stuff for 2017x
-- Currently unused because the remix isn't finished yet!
-- And I don't want to re-use the OG Subterfuge without permission.
--[[
local playingSong = false
local waitToPlay = 100
local currentSong = nil

local SONGTABLE_SONIC = {
    "stf_part_1.ogg",
    --"stf_part_2.ogg",
    "stf_part_3.ogg",
}

local function play_song()
    playingSong = true
    currentSong = audio_stream_load(SONGTABLE_SONIC[_G.charSelect.character_get_current_costume(CT_2017X)])
    if currentSong ~= nil then
        audio_stream_set_looping(currentSong, true)
        audio_stream_play(currentSong, true, 1)
    end
end

local function stop_song()
    playingSong = false
    waitToPlay = 100
    if currentSong ~= nil then
        audio_stream_stop(currentSong)
        currentSong = nil
    end
end

local function song_update(m)
    if not CSloaded or m.playerIndex ~= 0 then return end

    if not _G.charSelect.is_menu_open() then
        if playingSong then stop_song() end
        if waitToPlay < 100 then waitToPlay = 100 end
        return
    end

    if _G.charSelect.character_get_current_number() == CT_2017X and not playingSong then
        if waitToPlay > 0 then
            waitToPlay = waitToPlay - 1
            if waitToPlay == 0 then play_song() end
        end
    elseif _G.charSelect.character_get_current_number() ~= CT_2017X and playingSong then stop_song() end
end

local function on_character_update(m)
    on_character_snore(m)
    song_update(m)
end
]]

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)
-- hook_event(HOOK_MARIO_UPDATE, on_character_update)
